#-*- coding: utf-8 -*-

'''
    DOKITV Installer
    Copyright (C) 2017 Doki
    Based on the installer from unknown dev

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''


import urllib, urllib2, cookielib, os, sys
import xbmc, xbmcaddon, xbmcgui, xbmcplugin

USER_AGENT = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'

headers = {'User-Agent': USER_AGENT,
           'Accept': '*/*',
           'Connection': 'keep-alive'}


ADDON=xbmcaddon.Addon(id='plugin.program.dokitv')
dialog = xbmcgui.Dialog()
dokiuser = ADDON.getSetting('dokiuser')
dokipass = ADDON.getSetting('dokipass')
dokilogin = "http://account.dokitv.nl/member"
versieurl = "http://www.dokitv.nl/dokitv/versies.txt"
profileDir = ADDON.getAddonInfo('profile')
profileDir = xbmc.translatePath(profileDir).decode("utf-8")
cookiePath = os.path.join(profileDir, 'cookies.lwp')
versietxt = xbmc.translatePath(os.path.join('special://home/userdata','versie.txt'))
dokichange = xbmc.translatePath(os.path.join('special://home/userdata','dokichange.txt'))
kodiver = xbmc.getInfoLabel("System.BuildVersion").split(".")[0]
color1 = "palegreen"
color2 = "red"

if not os.path.exists(profileDir):
    os.makedirs(profileDir)

urlopen = urllib2.urlopen
cj = cookielib.LWPCookieJar(cookiePath)
Request = urllib2.Request

if cj != None:
    if os.path.isfile(cookiePath):
        try:
            cj.load()
        except:
            try:
                os.remove(cookiePath)
                pass
            except:
                pass
    cookie_handler = urllib2.HTTPCookieProcessor(cj)
    opener = urllib2.build_opener(cookie_handler, urllib2.HTTPBasicAuthHandler(), urllib2.HTTPHandler())
else:
    opener = urllib2.build_opener()

urllib2.install_opener(opener)


def getHtml2(url):
    req = Request(url)
    response = urlopen(req, timeout=60)
    data = response.read()
    response.close()
    return data


def postHtml(url, form_data={}, headers={}, compression=True, NoCookie=None):
    _user_agent = 'Mozilla/5.0 (X11; Linux i686) AppleWebKit/535.1 ' + \
                  '(KHTML, like Gecko) Chrome/13.0.782.99 Safari/535.1'
    req = urllib2.Request(url)
    if form_data:
        form_data = urllib.urlencode(form_data)
        req = urllib2.Request(url, form_data)
    req.add_header('User-Agent', _user_agent)
    for k, v in headers.items():
        req.add_header(k, v)
    if compression:
        req.add_header('Accept-Encoding', 'gzip')
    response = urllib2.urlopen(req, timeout=30)
    data = response.read()
    if not NoCookie:
        try:
            cj.save(cookiePath)
        except: pass
    response.close()
    return data


def login(url):
    if dokiuser is "" or dokipass is "":
        try: os.remove(cookiePath)
        except: pass
        return 'nologin'
    formdata = dict(amember_login = dokiuser, amember_pass = dokipass)
    try:
        test = postHtml(url, formdata, headers)
    except Exception, e:
        fout = '%s - %s' %(Exception, str(e))
        addDir('Error: %s' % fout,'','','','','', folder=False)
        return 'error'
    if 'gebruikersnaam of wachtwoord is onjuist' in test:
        return 'wrong'
    elif 'Authenticatie probleem' in test:
        return 'banned'
    elif 'Ingelogd als' in test:
        return 'logged'


def checkUpdate():
    versies = {'cbuild':'',
               'cversion':''}
               
    if os.path.isfile(versietxt):
        file = open(versietxt, 'r'); versie = file.read(); file.close();
        if not ';' in versie:
            cbuild = 'Doki'
            cversie = versie
        else:
            cbuild, cversie = versie.split(';')
        versies['cbuild'] = cbuild
        versies['cversion'] = cversie
        try:
            updatev = getHtml2(versieurl)
            updatev = updatev.split('\n')
            for regels in updatev:
                regel = regels.split(';')
                versies[regel[0]] = regel[1]
        except:
            versies['status'] = 'noupdate'
            return versies
        if cbuild in versies:
            versies['status'] = 'update' if int(versies[cbuild]) > int(cversie) else "noupdate"
        else: versies['status'] = 'noupdate'
    else: versies['status'] = 'notinstalled'
    return versies


def textBox(heading,announce):
    class TextBox():
        WINDOW=10147
        CONTROL_LABEL=1
        CONTROL_TEXTBOX=5
        def __init__(self,*args,**kwargs):
            xbmc.executebuiltin("ActivateWindow(%d)" % (self.WINDOW, ))
            self.win=xbmcgui.Window(self.WINDOW)
            xbmc.sleep(500)
            self.setControls()
        def setControls(self):
            self.win.getControl(self.CONTROL_LABEL).setLabel(heading)
            try: f=open(announce); text=f.read()
            except: text=announce
            self.win.getControl(self.CONTROL_TEXTBOX).setText(str(text))
            return
    TextBox()
    while xbmc.getCondVisibility('Window.IsVisible(10147)'):
        xbmc.sleep(500)
        

def enableAddons(melding=None, update=True):
    if int(kodiver) > 16.5:
        try:    from sqlite3 import dbapi2 as database
        except: from pysqlite2 import dbapi2 as database
        
        db_dir = xbmc.translatePath("special://profile/Database")
        db_path = os.path.join(db_dir, 'Addons27.db')
        conn = database.connect(db_path)
        conn.text_factory = str
        
        addonfolder=xbmc.translatePath(os.path.join('special://home','addons'))
        contents = os.listdir(addonfolder)
        conn.executemany('update installed set enabled=1 WHERE addonID = (?)', ((val,) for val in contents))
        conn.commit()
        if update:
            xbmc.executebuiltin('UpdateAddonRepos()')
            xbmc.executebuiltin('UpdateLocalAddons()')
        if melding:
            dialog.ok("[COLOR %s][B]Addons enabled[/COLOR][/B]" % color1, 'Alle addons staan nu aan!')


def addDir(name,url,mode,iconimage,fanart,description,folder=True):
    name = name.replace('/s',' ')
    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)
    ok=True
    liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
    liz.setProperty( "Fanart_Image", fanart )
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=folder)
    return ok
    